--[[
Name: Where's He Gone Now?
Revision: $Revision: 6 $
Author(s): ThePants999
Website: http://http://www.wowace.com/addons/wheres-he-gone-now/
SVN: svn://svn.wowace.com/wow/wheres-he-gone-now/mainline/trunk
Description: Keeps an eye on someone's distance from you, and alerts you if they get too far.
License: GNU General Public License version 3 (GPLv3)
]]

local AppName = "Where's He Gone Now?"
local VERSION = AppName .. " -r" .. ("$Revision: 6 $"):match("%d+")

local rc = LibStub("LibRangeCheck-2.0")
WHGN = LibStub("AceAddon-3.0"):NewAddon(AppName, "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

-- Config
local UpdateInterval = 0.5
local PlayerName = "Fruttester"
local MaxRange = 20

-- State
local WarningActive = false

function WHGN:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("WHGN_DB")
  self:Print("WHGN is alive!")
end

function WHGN:OnEnable(first)
  self.timer = self:ScheduleRepeatingTimer("TimerPop", UpdateInterval)
  WarningActive = false
end

function WHGN:OnDisable()
  self:UnregisterAllEvents()
  self:CancelAllTimers()
end

function WHGN:TimerPop()
  if WarningActive then
    -- We've already warned the player. Check to see if we're OK again.
    if (UnitInParty(PlayerName) or UnitInRaid(PlayerName)) and (UnitAffectingCombat("player") or UnitAffectingCombat(PlayerName)) then
      -- Still in combat; range is relevant.
      local min, max = rc:GetRange(PlayerName)
      local range = 0
      
      if min and max then
        range = (min + max) / 2
      elseif min then
        range = min
      elseif max then
        range = max
      end
      
      if range <= MaxRange then
        -- Back within range, phew.
        WarningActive = false
      end
    else
      -- No longer in combat, or no longer grouped.
      WarningActive = false
    end
  else
    -- Warning currently inactive. Do we now have a problem?
    
    if (UnitInParty(PlayerName) or UnitInRaid(PlayerName)) and (UnitAffectingCombat("player") or UnitAffectingCombat(PlayerName)) then
      -- In combat; range is relevant.
      local min, max = rc:GetRange(PlayerName)
      local range = 0
      
      if min and max then
        range = (min + max) / 2
      elseif min then
        range = min
      elseif max then
        range = max
      end
      
      if range > MaxRange then
        -- Noooo! Out of range!
        self:Print(PlayerName .. " is getting away!")
        PlaySound("TellMessage")
        WarningActive = true
      end
    end
  end
end